package org.jamesii.experimentgeneration;


import javafx.application.Application;
import javafx.scene.control.Alert;
import javafx.scene.control.ButtonType;
import javafx.stage.Stage;
import org.jamesii.experimentgeneration.controller.generation.controller.MainExperimentController;
import org.jamesii.experimentgeneration.model.ExperimentModel;
import org.jamesii.experimentgeneration.view.View;

import java.util.Optional;

public class Main extends Application {


    private Stage window;


    @Override
    public void start(Stage primaryStage) {
        //Initiate Model, View, Controller
        ExperimentModel experimentModel = new ExperimentModel();
        View view = new View(experimentModel, primaryStage);
        MainExperimentController mainExperimentController = new MainExperimentController(experimentModel, view);

        window = primaryStage;
        window.setOnCloseRequest(e -> {
            e.consume();
            closeWindows();
        });

        window.setTitle("GrEASE Experiment Generator");




    }

    private void closeWindows() {
        Alert alert = new Alert(Alert.AlertType.CONFIRMATION);
        alert.setTitle("Closing Window");
        alert.setHeaderText("The system will close");
        alert.setContentText("Do you want to close the system?");

        Optional<ButtonType> result = alert.showAndWait();
        if (result.get() == ButtonType.OK) {
            window.close();
        } else if (result.get() == ButtonType.CANCEL) {
            alert.close();
        }
    }

    public static void main(String[] args) {


//
//        Configuration cfg = new Configuration();
//        cfg.setDefaultEncoding("UTF-8");
//        try {
//            cfg.setDirectoryForTemplateLoading(new File(".\\src\\main\\resources\\Templates"));
//            cfg.setTemplateExceptionHandler(TemplateExceptionHandler.RETHROW_HANDLER);
//        } catch (IOException e) {
//            e.printStackTrace();
//        }

//        try {
//            Template template = cfg.getTemplate("Stochastic-Experiments/stochastic_master.ftl");
//            LinkedHashMap map = new LinkedHashMap();
//            map.put("modelPath","Test");
//            map.put("observationType", "range");
//            ArrayList<Integer> list = new ArrayList<>();
//            list.add(1);
//            list.add(2);
//            list.add(3);
//            map.put("observationRange", list);
//            LinkedHashMap subMap = new LinkedHashMap();
//            subMap.put("key1", "asd");
//            subMap.put("key2", "ree");
//            map.put("observationTargets", subMap);
//            LinkedHashMap subMap2 = new LinkedHashMap();
//            subMap2.put("asd1", 432);
//            subMap2.put("asd2", 43);
//            subMap2.put("asd3", 2);
//            map.put("configuration", subMap2);
//            map.put("stopCondition", "atTime");
//            map.put("atTime", 10);
//            map.put("simulator", "SSA");
//            map.put("replications", 10);
//            Writer stringWriter = new StringWriter();
//            template.process(map, stringWriter);
//            System.out.println(stringWriter.toString());
//        } catch (IOException e) {
//            e.printStackTrace();
//        } catch (TemplateException e) {
//            e.printStackTrace();
//        }


        launch(args);


    }



}
