package org.jamesii.experimentgeneration.controller.generation.controller.backend;

import freemarker.template.Template;
import freemarker.template.TemplateException;
import org.jamesii.experimentgeneration.controller.generation.controller.MainExperimentController;
import org.jamesii.experimentgeneration.experiment.Experiment;
import org.jamesii.experimentgeneration.model.ExperimentModel;
import org.json.JSONArray;
import org.json.JSONObject;

import java.io.IOException;
import java.io.StringWriter;
import java.io.Writer;
import java.util.*;

/**
 * Created by Marcus on 17.12.2018.
 */
public class SesslBackendController extends BackendController implements Experiment, Observer {

    private MainExperimentController mainExperimentController;


    public SesslBackendController(MainExperimentController mainExperimentController) {
        super(mainExperimentController);
        this.mainExperimentController = mainExperimentController;

    }

    /**
     * Interface for various backend specific checks possible here
     * @param jsonObject
     * @return
     */
    @Override
    public boolean check(JSONObject jsonObject) {

        return true;
    }



    @Override
    public void adjustModelPath(HashMap parameters) {
        ExperimentModel experimentModel = mainExperimentController.getExperimentModel();
        adaptModelPath(experimentModel);
    }

    @Override
    public void generateExperiment(ExperimentModel experimentModel, Template template) {
        try {
            Writer stringWriter = new StringWriter();
            template.process(experimentModel.getExperimentSpecification(), stringWriter);
            String experimentDescription = stringWriter.toString();
            experimentModel.setExperimentDescription(experimentDescription);
            mainExperimentController.getView().getEditorView().getExperimentTextArea().setText(experimentDescription);
        } catch (IOException | TemplateException e) {
            e.printStackTrace();
        }
    }

    @Override
    public void update(Observable o, Object arg) {

    }
}
