package org.jamesii.experimentgeneration.controller.generation.controller.backend;

import freemarker.template.Template;
import freemarker.template.TemplateException;
import org.jamesii.experimentgeneration.controller.generation.controller.MainExperimentController;
import org.jamesii.experimentgeneration.model.ExperimentModel;
import org.json.JSONObject;

import java.io.IOException;
import java.io.StringWriter;
import java.io.Writer;
import java.util.HashMap;

public class YamlBackendController extends BackendController {

    private MainExperimentController mainExperimentController;
    public YamlBackendController(MainExperimentController mainExperimentController){
        super(mainExperimentController);
        this.mainExperimentController = mainExperimentController;
    }




    @Override
    public boolean check(JSONObject jsonObject) {
        return true;
    }

    @Override
    public void adjustModelPath(HashMap parameters) {
        ExperimentModel experimentModel = mainExperimentController.getExperimentModel();
        adaptModelPath(experimentModel);
    }

    @Override
    public void generateExperiment(ExperimentModel experimentModel, Template template) {
        try {
            Writer stringWriter = new StringWriter();
            template.process(experimentModel.getExperimentSpecification(), stringWriter);
            String experimentDescription = stringWriter.toString();
            experimentModel.setExperimentDescription(experimentDescription);
            mainExperimentController.getView().getEditorView().getExperimentTextArea().setText(experimentDescription);
        } catch (IOException | TemplateException e) {
            e.printStackTrace();
        }
    }
}
